--- ChangeLog	2005/06/01 14:15:59	1.6
+++ ChangeLog	2005/06/10 12:57:31
@@ -1,4 +1,9 @@
+2005-06-10  Joerg Hoehle <hoehle@users.sourceforge.net>
+
+	* swank-clisp (describe-symbol-for-emacs): Report :setf and :type
+	where appropriate.
+
 2005-05-31  Joerg Hoehle <hoehle@users.sourceforge.net>
 
 	* swank-clisp.lisp (getpid): Define always (slime needs it)
--- swank-clisp.lisp	2005/05/31 09:41:37	1.5
+++ swank-clisp.lisp	2005/06/10 13:08:28	1.7
@@ -158,8 +158,15 @@
 	       ;; (type-of 'progn) -> ext:special-operator
 	       (t                :special-operator)))
 	 (doc 'function)))
-      (maybe-push :class (when (find-class symbol nil) 
-			   (doc 'type))) ;this should be fixed
+      (when (or (get symbol 'system::setf-function) ; e.g. #'(setf elt)
+		(get symbol 'system::setf-expander)); defsetf
+	(maybe-push :setf (doc 'setf)))
+      (when (or (get symbol 'system::type-symbol); cf. clisp/src/describe.lisp
+		(get symbol 'system::defstruct-description)
+		(get symbol 'system::deftype-expander))
+	(maybe-push :type (doc 'type))) ; even for 'structure
+      (when (find-class symbol nil)
+	(maybe-push :class (doc 'type)))
       ;; Let this code work compiled in images without FFI
       (let ((types (load-time-value
 		    (and (find-package "FFI")
